Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/clmain.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/clmain.F	(revision 3)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/clmain.F	(revision 300)
@@ -593,60 +789,77 @@
       ENDDO
       ENDDO
+C
+C nouvelle formulation JL Dufresne
+C
+C q1 = zx_cq(i,1) + zx_dq(i,1) * Flux_Q(i,1) * dt
+C h1 = zx_ch(i,1) + zx_dh(i,1) * Flux_H(i,1) * dt
+C
       DO i = 1, knon
          zx_buf1(i) = delp(i,1) + zx_coef(i,2)*(1.-zx_dq(i,2))
-     .              + zx_coef(i,1)*beta(i)
-     .                *(zx_alf1(i)+zx_alf2(i)*zx_dq(i,2))
          zx_cq(i,1) = (local_q(i,1)*delp(i,1)
-     .                 +zx_coef(i,2)*z_gamaq(i,2)
-     .                 +zx_cq(i,2)*(zx_coef(i,2)
-     .                  -zx_coef(i,1)*zx_alf2(i)*beta(i)) )
+     .                 +zx_coef(i,2)*(z_gamaq(i,2)+zx_cq(i,2)))
      .                /zx_buf1(i)
-         zx_dq(i,1) = beta(i) * zx_coef(i,1) / zx_buf1(i)
+         zx_dq(i,1) = -1. * RG / zx_buf1(i)
 c
          zx_buf2(i) = delp(i,1) + zx_coef(i,2)*(1.-zx_dh(i,2))
-     .               +zx_coef(i,1)
-     .                *(zx_alf1(i)+zx_alf2(i)*zx_dh(i,2))
          zx_ch(i,1) = (local_h(i,1)*delp(i,1)
-     .                 +zx_coef(i,2)*z_gamah(i,2)
-     .                 +zx_ch(i,2)*(zx_coef(i,2)
-     .                  -zx_coef(i,1)*zx_alf2(i)) )
+     .                 +zx_coef(i,2)*(z_gamah(i,2)+zx_ch(i,2)))
      .                /zx_buf2(i)
-         zx_dh(i,1) = zx_coef(i,1) / zx_buf2(i)
-      ENDDO
-c==== calculer d'abord local_h(0) ============================
-      DO i = 1, knon
-         zx_sl(i) = RLVTT
-         if (local_ts(i) .LT. RTT) zx_sl(i) = RLSTT
-      ENDDO
-      DO i = 1, knon
-         zx_h_grnd = t_grnd * zx_pkh(i,1) *RCPD
-         zx_h_ts(i) = local_ts(i) * zx_pkh(i,1) *RCPD
-         zx_a = radsol(i)
-     .        + zx_coef(i,1)/(RG*dtime)*beta(i)*zx_sl(i)
-     .          *(zx_cq(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dq(i,2))
-     .            +zx_alf2(i)*zx_cq(i,2))
-     .        + zx_coef(i,1)/(RG*dtime)*beta(i)*zx_sl(i)
-     .          *((zx_dq(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dq(i,2))
-     .             -1.0)*zx_cq0(i))
-     .        + zx_coef(i,1)/(RG*dtime)/zx_pkh(i,1)
-     .          *(zx_ch(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dh(i,2))
-     .           +zx_alf2(i)*zx_ch(i,2))
-         zx_a = zx_h_ts(i) + dif_grnd(i)*dtime*zx_h_grnd
-     .                     + cal(i)*zx_pkh(i,1)*dtime * zx_a 
-         zx_b = zx_coef(i,1)/(RG*dtime) *beta(i)*zx_sl(i)*zx_dq0(i)
-     .          *(1.0-zx_dq(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dq(i,2)))
-     .        + zx_coef(i,1)/(RG*dtime)/zx_pkh(i,1)
-     .          *(1.0-zx_dh(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dh(i,2)))
-         zx_b = 1.0 + dif_grnd(i)*dtime + cal(i)*zx_pkh(i,1)*dtime*zx_b
-         zx_h_ts(i) = zx_a / zx_b
-         local_ts(i) = zx_h_ts(i) / zx_pkh(i,1)/RCPD
-      ENDDO
+         zx_dh(i,1) = -1. * RG / zx_buf2(i)
+      ENDDO
+
+C Appel a interfsurf (appel generique) routine d'interface avec la surface
+
+c initialisation
+       petAcoef =0. 
+	peqAcoef = 0.
+	petBcoef =0.
+	peqBcoef = 0.
+	p1lay =0.
+	
+c      do i = 1, knon
+        petAcoef(1:knon) = zx_ch(1:knon,1)
+        peqAcoef(1:knon) = zx_cq(1:knon,1)
+        petBcoef(1:knon) =  zx_dh(1:knon,1)
+        peqBcoef(1:knon) = zx_dq(1:knon,1)
+        tq_cdrag(1:knon) =coef(1:knon,1)
+        temp_air(1:knon) =t(1:knon,1)
+        epot_air(1:knon) =local_h(1:knon,1)
+        spechum(1:knon)=q(1:knon,1)
+        p1lay(1:knon) = pplay(1:knon,1)
+        zlev1(1:knon) = delp(1:knon,1)
+c        swnet = swdown * (1. - albedo)
+        swdown(1:knon) = swnet(1:knon)
+c      enddo
+c En attendant mieux
+      ccanopy = 365.
+
+      CALL interfsurf(itime, dtime, date0, jour, rmu0,
+     e klon, iim, jjm, nisurf, knon, knindex, pctsrf, 
+     e rlon, rlat, cufi, cvfi, 
+     e debut, lafin, ok_veget, soil_model, nsoilmx,tsoil,
+     e zlev1,  u1lay, v1lay, temp_air, spechum, epot_air, ccanopy, 
+     e tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef,
+     e precip_rain, precip_snow, sollw, sollwdown, swnet, swdown,
+     e fder, taux, tauy, rugos, rugoro,
+     e albedo, snow, qsol,
+     e ts, p1lay, psref, radsol,
+     e ocean, npas, nexca, zmasq,
+     s evap, fluxsens, fluxlat, dflux_l, dflux_s,              
+     s tsol_rad, tsurf_new, alb_new, alblw, emis_new, z0_new, 
+     s pctsrf_new, agesno)
+
+
+      do i = 1, knon
+        flux_t(i,1) = fluxsens(i)
+        flux_q(i,1) = - evap(i)
+        d_ts(i) = tsurf_new(i) - ts(i)
+        albedo(i) = alb_new(i)
+      enddo
+
 c==== une fois on a zx_h_ts, on peut faire l'iteration ========
       DO i = 1, knon
-         zx_q_0(i) = zx_cq0(i) + zx_dq0(i)*zx_h_ts(i)
-      ENDDO
-      DO i = 1, knon
-         local_h(i,1) = zx_ch(i,1) + zx_dh(i,1)*zx_h_ts(i)
-         local_q(i,1) = zx_cq(i,1) + zx_dq(i,1)*zx_q_0(i)
+         local_h(i,1) = zx_ch(i,1) + zx_dh(i,1)*flux_t(i,1)*dtime
+         local_q(i,1) = zx_cq(i,1) + zx_dq(i,1)*flux_q(i,1)*dtime
       ENDDO
       DO k = 2, klev
@@ -659,13 +872,4 @@
 c== flux_q est le flux de vapeur d'eau: kg/(m**2 s)  positive vers bas
 c== flux_t est le flux de cpt (energie sensible): j/(m**2 s)
-      DO i = 1, knon
-        flux_q(i,1) = (zx_coef(i,1)/dtime/RG) * beta(i)
-     .              * (local_q(i,1)*zx_alf1(i)
-     .                +local_q(i,2)*zx_alf2(i)-zx_q_0(i))
-        flux_t(i,1) = (zx_coef(i,1)/dtime/RG)
-     .              * (local_h(i,1)*zx_alf1(i)
-     .                +local_h(i,2)*zx_alf2(i)-zx_h_ts(i))
-     .              / zx_pkh(i,1)
-      ENDDO
       DO k = 2, klev
       DO i = 1, knon
@@ -678,14 +882,5 @@
       ENDDO
 c======================================================================
-c Derives des flux dF/dTs (W m-2 K-1):
-      DO i = 1, knon
-         dflux_s(i) = (RCPD*zx_coef(i,1))/(RG*dtime)/zx_pkh(i,1)
-     .         *(zx_dh(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dh(i,2))-1.0)
-         dflux_l(i) = (beta(i)*RLVTT*RCPD*zx_coef(i,1))/(RG*dtime)
-     .         *zx_dq0(i)
-     .         *(zx_dq(i,1)*(zx_alf1(i)+zx_alf2(i)*zx_dq(i,2))-1.0)
-         dflux_g(i) = dif_grnd(i) * RCPD
-      ENDDO
-c======================================================================
+C Calcul tendances
       DO k = 1, klev
       DO i = 1, knon
@@ -694,8 +889,6 @@
       ENDDO
       ENDDO
-      DO i = 1, knon
-         d_ts(i) = local_ts(i) - ts(i)
-      ENDDO
-c
+c
+
       RETURN
       END
@@ -836,5 +1029,4 @@
 c ts-------input-R- temperature du sol (en Kelvin)
 c rugos----input-R- longeur de rugosite (en m)
-c xlat-----input-R- latitude en degree
 c u--------input-R- vitesse u
 c v--------input-R- vitesse v
@@ -858,5 +1050,4 @@
       REAL u(klon,klev), v(klon,klev), t(klon,klev), q(klon,klev)
       REAL rugos(klon)
-      REAL xlat(klon)
 c
       REAL pcfm(klon,klev), pcfh(klon,klev)
@@ -873,5 +1064,5 @@
       PARAMETER (clam=160.0)
       REAL ratqs ! largeur de distribution de vapeur d'eau
-      PARAMETER (ratqs=0.2)
+      PARAMETER (ratqs=0.05)
       LOGICAL richum ! utilise le nombre de Richardson humide
       PARAMETER (richum=.TRUE.)
@@ -881,5 +1072,5 @@
       PARAMETER (prandtl=0.4)
       REAL kstable ! diffusion minimale (situation stable)
-      PARAMETER (kstable=1.0e-06)
+      PARAMETER (kstable=1.0e-10)
       REAL mixlen ! constante controlant longueur de melange
       PARAMETER (mixlen=35.0)
@@ -911,4 +1102,7 @@
 c contre-gradient pour la chaleur sensible: Kelvin/metre
       REAL gamt(2:klev)
+c essai qsurf
+      real qsurf(klon)
+      real friv, frih
 c
       LOGICAL appel1er
@@ -947,8 +1141,13 @@
          itop(i) = 0
       ENDDO
+
+      do i = 1, knon
+        qsurf(i) = qsatl(ts(i))/paprs(i,1)
+      enddo
+
 c
 c Prescrire la valeur de contre-gradient
 c
-      IF (contreg) THEN
+      IF (.NOT.contreg) THEN
          DO k = 2, klev
             gamt(k) = 0.0
@@ -980,5 +1179,6 @@
          zdu2=max(cepdu2,u(i,1)**2+v(i,1)**2)
          zdphi=zgeop(i,1)
-         ztsolv = ts(i) * (1.0+RETV*q(i,1)) ! qsol approx = q(i,1)
+c         ztsolv = ts(i) * (1.0+RETV*q(i,1)) ! qsol approx = q(i,1)
+         ztsolv = ts(i) * (1.0+RETV*qsurf(i))
          ztvd=(t(i,1)+zdphi/RCPD/(1.+RVTMP2*q(i,1)))
      .       *(1.+RETV*q(i,1))
@@ -988,6 +1188,10 @@
            IF (.NOT.zxli) THEN
            zscf=SQRT(1.+cd*ABS(zri(i)))
-           zcfm1(i) = zcdn/(1.+2.0*cb*zri(i)/zscf)
-           zcfh1(i) = zcdn/(1.+3.0*cb*zri(i)*zscf)
+           FRIV = AMAX1(1. / (1.+2.*CB*zri(i)/ZSCF), 0.1)
+!           zcfm1(i) = zcdn/(1.+2.0*cb*zri(i)/ zscf)
+           zcfm1(i) = zcdn * FRIV
+           FRIH = AMAX1(1./ (1.+3.*CB*zri(i)*ZSCF), 0.1 )
+!           zcfh1(i) = zcdn/(1.+3.0*cb*zri(i)*zscf)
+           zcfh1(i) = zcdn * FRIH
            pcfm(i,1) = zcfm1(i)
            pcfh(i,1) = zcfh1(i)
@@ -1000,6 +1204,6 @@
            zucf=1./(1.+3.0*cb*cc*zcdn*SQRT(ABS(zri(i))
      .              *(1.0+zgeop(i,1)/(RG*rugos(i)))))
-           zcfm2(i) = zcdn*(1.-2.0*cb*zri(i)*zucf)
-           zcfh2(i) = zcdn*(1.-3.0*cb*zri(i)*zucf)
+           zcfm2(i) = zcdn*amax1((1.-2.0*cb*zri(i)*zucf),0.1)
+           zcfh2(i) = zcdn*amax1((1.-3.0*cb*zri(i)*zucf),0.1)
            pcfm(i,1) = zcfm2(i)
            pcfh(i,1) = zcfh2(i)
@@ -1012,4 +1216,5 @@
          ENDIF
       ENDDO
+
 c
 c Calculer les coefficients turbulents dans l'atmosphere
@@ -1131,5 +1336,102 @@
       RETURN
       END
-      SUBROUTINE calbeta(dtime,indice,snow,qsol,
+      SUBROUTINE coefkz2(nsrf, knon, paprs, pplay,t,
+     .                  pcfm, pcfh)
+      IMPLICIT none
+c======================================================================
+c J'introduit un peu de diffusion sauf dans les endroits
+c ou une forte inversion est presente
+c On peut dire qu'il represente la convection peu profonde
+c
+c Arguments:
+c nsrf-----input-I- indicateur de la nature du sol
+c knon-----input-I- nombre de points a traiter
+c paprs----input-R- pression a chaque intercouche (en Pa)
+c pplay----input-R- pression au milieu de chaque couche (en Pa)
+c t--------input-R- temperature (K)
+c
+c pcfm-----output-R- coefficients a calculer (vitesse)
+c pcfh-----output-R- coefficients a calculer (chaleur et humidite)
+c======================================================================
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+#include "indicesol.h"
+c
+c Arguments:
+c
+      INTEGER knon, nsrf
+      REAL paprs(klon,klev+1), pplay(klon,klev)
+      REAL t(klon,klev)
+c
+      REAL pcfm(klon,klev), pcfh(klon,klev)
+c
+c Quelques constantes et options:
+c
+      REAL prandtl
+      PARAMETER (prandtl=0.4)
+      REAL kstable
+      PARAMETER (kstable=0.002)
+ccc      PARAMETER (kstable=0.001)
+      REAL mixlen ! constante controlant longueur de melange
+      PARAMETER (mixlen=35.0)
+      REAL seuil ! au-dela l'inversion est consideree trop faible
+      PARAMETER (seuil=-0.02)
+ccc      PARAMETER (seuil=-0.04)
+ccc      PARAMETER (seuil=-0.06)
+ccc      PARAMETER (seuil=-0.09)
+c
+c Variables locales:
+c
+      INTEGER i, k, invb(knon)
+      REAL zl2(knon)
+      REAL zdthmin(knon), zdthdp
+c
+c Initialiser les sorties
+c
+      DO k = 1, klev
+      DO i = 1, knon
+         pcfm(i,k) = 0.0
+         pcfh(i,k) = 0.0
+      ENDDO
+      ENDDO
+c
+c Chercher la zone d'inversion forte
+c
+      DO i = 1, knon
+         invb(i) = klev
+         zdthmin(i)=0.0
+      ENDDO
+      DO k = 2, klev/2-1
+      DO i = 1, knon
+         zdthdp = (t(i,k)-t(i,k+1))/(pplay(i,k)-pplay(i,k+1))
+     .          - RD * 0.5*(t(i,k)+t(i,k+1))/RCPD/paprs(i,k+1)
+         zdthdp = zdthdp * 100.0
+         IF (pplay(i,k).GT.0.8*paprs(i,1) .AND.
+     .       zdthdp.LT.zdthmin(i) ) THEN
+            zdthmin(i) = zdthdp
+            invb(i) = k
+         ENDIF
+      ENDDO
+      ENDDO
+c
+c Introduire une diffusion:
+c
+      DO k = 2, klev
+      DO i = 1, knon
+      IF ( (nsrf.NE.is_oce) .OR.  ! si ce n'est pas sur l'ocean
+     .     (invb(i).EQ.klev) .OR. ! s'il n'y a pas d'inversion
+     .     (zdthmin(i).GT.seuil) )THEN ! si l'inversion est trop faible
+         zl2(i)=(mixlen*MAX(0.0,(paprs(i,k)-paprs(i,klev+1))
+     .                       /(paprs(i,2)-paprs(i,klev+1)) ))**2
+         pcfm(i,k)= zl2(i)* kstable
+         pcfh(i,k) = pcfm(i,k) /prandtl ! h et m different
+      ENDIF
+      ENDDO
+      ENDDO
+c
+      RETURN
+      END
+      SUBROUTINE calbeta(dtime,indice,knon,snow,qsol,
      .                    vbeta,vcal,vdif)
       IMPLICIT none
@@ -1146,5 +1448,6 @@
 #include "indicesol.h"
       REAL tau_gl ! temps de relaxation pour la glace de mer
-      PARAMETER (tau_gl=86400.0*30.0)
+ccc      PARAMETER (tau_gl=86400.0*30.0)
+      PARAMETER (tau_gl=86400.0*5.0)
       REAL mx_eau_sol
       PARAMETER (mx_eau_sol=150.0)
@@ -1158,6 +1461,6 @@
 c
       REAL dtime
-      REAL snow(klon,nbsrf), qsol(klon,nbsrf)
-      INTEGER indice
+      REAL snow(klon), qsol(klon)
+      INTEGER indice, knon
 C
       REAL vbeta(klon)
@@ -1165,6 +1468,7 @@
       REAL vdif(klon)
 C
+
       IF (indice.EQ.is_oce) THEN
-      DO i = 1, klon
+      DO i = 1, knon
           vcal(i)   = 0.0
           vbeta(i)  = 1.0
@@ -1174,18 +1478,18 @@
 c
       IF (indice.EQ.is_sic) THEN
-      DO i = 1, klon
+      DO i = 1, knon
           vcal(i) = calice
-          IF (snow(i,is_sic) .GT. 0.0) vcal(i) = calsno
+          IF (snow(i) .GT. 0.0) vcal(i) = calsno
           vbeta(i)  = 1.0
-ccc          vdif(i) = 1.0/tau_gl ! c'etait une erreur
-          vdif(i) = calice/tau_gl
+          vdif(i) = 1.0/tau_gl
+ccc          vdif(i) = calice/tau_gl ! c'etait une erreur
       ENDDO
       ENDIF
 c
       IF (indice.EQ.is_ter) THEN
-      DO i = 1, klon
+      DO i = 1, knon
           vcal(i) = calsol
-          IF (snow(i,is_ter) .GT. 0.0) vcal(i) = calsno
-          vbeta(i)  = MIN(2.0*qsol(i,is_ter)/mx_eau_sol, 1.0)
+          IF (snow(i) .GT. 0.0) vcal(i) = calsno
+          vbeta(i)  = MIN(2.0*qsol(i)/mx_eau_sol, 1.0)
           vdif(i) = 0.0
       ENDDO
@@ -1193,7 +1497,7 @@
 c
       IF (indice.EQ.is_lic) THEN
-      DO i = 1, klon
+      DO i = 1, knon
           vcal(i) = calice
-          IF (snow(i,is_lic) .GT. 0.0) vcal(i) = calsno
+          IF (snow(i) .GT. 0.0) vcal(i) = calsno
           vbeta(i)  = 1.0
           vdif(i) = 0.0
Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/condsurf.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/condsurf.F	(revision 3)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/condsurf.F	(revision 300)
@@ -1,2 +1,4 @@
+c $Header$
+c
       SUBROUTINE condsurf( jour, jourvrai, pctsrf,
      s                    lmt_sst,lmt_alb,lmt_rug,lmt_bils )
@@ -31,5 +33,5 @@
 
       LOGICAL newlmt
-      PARAMETER (newlmt=.FALSE.)
+      PARAMETER (newlmt=.TRUE.)
 
       INTEGER     nannemax
@@ -43,9 +45,4 @@
       REAL lmt_rug(klon) ! longeur de rugosite du sol
       REAL lmt_bils(klon)
-c
-c Couplage OASIS:
-#include "oasis.h"
-      REAL cpl_sst(iim,jjm+1), cpl_sic(iim,jjm+1)
-      REAL cpl_alb_sst(iim,jjm+1), cpl_alb_sic(iim,jjm+1)
 c
 c Variables locales:
@@ -119,21 +116,23 @@
       IF (newlmt) THEN
 c
-c Fraction "ocean":
-      ierr = NF_INQ_VARID (nid, "FOCE", nvarid)
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "condsurf: Le champ <FOCE> est absent"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_oce))
-#else
-      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_oce))
-#endif
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "condsurf: Lecture echouee pour <FOCE>"
-         CALL abort
-      ENDIF
+c$$$c Fraction "ocean":
+c$$$      ierr = NF_INQ_VARID (nid, "FOCE", nvarid)
+c$$$      IF (ierr .NE. NF_NOERR) THEN
+c$$$         PRINT*, "condsurf: Le champ <FOCE> est absent"
+c$$$         CALL abort
+c$$$      ENDIF
+c$$$#ifdef NC_DOUBLE
+c$$$      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_oce))
+c$$$#else
+c$$$      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_oce))
+c$$$#endif
+c$$$      IF (ierr .NE. NF_NOERR) THEN
+c$$$         PRINT*, "condsurf: Lecture echouee pour <FOCE>"
+c$$$         CALL abort
+c$$$      ENDIF
 c
 c Fraction "glace de mer":
+c
+c
       ierr = NF_INQ_VARID (nid, "FSIC", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
@@ -150,36 +149,54 @@
          CALL abort
       ENDIF
-c
-c Fraction "terre":
-      ierr = NF_INQ_VARID (nid, "FTER", nvarid)
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "condsurf: Le champ <FTER> est absent"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_ter))
-#else
-      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_ter))
-#endif
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "condsurf: Lecture echouee pour <FTER>"
-         CALL abort
-      ENDIF
-c
-c Fraction "glacier terre":
-      ierr = NF_INQ_VARID (nid, "FLIC", nvarid)
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "condsurf: Le champ <FLIC> est absent"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_lic))
-#else
-      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_lic))
-#endif
-      IF (ierr .NE. 0) THEN
-         PRINT*, "condsurf: Lecture echouee pour <FLIC>"
-         CALL abort
-      ENDIF
+C 
+C positionnement % ocean libre et verification qu'il y a compatibilite des soussurfaces
+      pctsrf(1 : klon, is_oce) = (1. - zmasq(1 : klon)) 
+     $    - pctsrf(1 : klon, is_sic)
+      DO i = 1, klon
+        IF ( pctsrf(i, is_sic) .GT. (1. - zmasq(i)) ) THEN
+            WRITE(*,*) 'condsurf : sea-ice et masque pb en ', i,
+     $     pctsrf(i, is_sic), (1. - zmasq(i))     
+            pctsrf(i, is_sic) = (1. - zmasq(i))
+            pctsrf(i, is_oce) = 0.
+        ENDIF          
+        IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
+     $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
+     $       THEN 
+             WRITE(*,*) 'condsurf : pb sous surface au point ', i, 
+     $           pctsrf(i, 1 : nbsrf)
+         ENDIF 
+      END DO 
+c
+c$$$c Fraction "terre":
+c$$$      ierr = NF_INQ_VARID (nid, "FTER", nvarid)
+c$$$      IF (ierr .NE. NF_NOERR) THEN
+c$$$         PRINT*, "condsurf: Le champ <FTER> est absent"
+c$$$         CALL abort
+c$$$      ENDIF
+c$$$#ifdef NC_DOUBLE
+c$$$      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_ter))
+c$$$#else
+c$$$      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_ter))
+c$$$#endif
+c$$$      IF (ierr .NE. NF_NOERR) THEN
+c$$$         PRINT*, "condsurf: Lecture echouee pour <FTER>"
+c$$$         CALL abort
+c$$$      ENDIF
+c$$$c
+c$$$c Fraction "glacier terre":
+c$$$      ierr = NF_INQ_VARID (nid, "FLIC", nvarid)
+c$$$      IF (ierr .NE. NF_NOERR) THEN
+c$$$         PRINT*, "condsurf: Le champ <FLIC> est absent"
+c$$$         CALL abort
+c$$$      ENDIF
+c$$$#ifdef NC_DOUBLE
+c$$$      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,debut,epais,pctsrf(1,is_lic))
+c$$$#else
+c$$$      ierr = NF_GET_VARA_REAL(nid,nvarid,debut,epais,pctsrf(1,is_lic))
+c$$$#endif
+c$$$      IF (ierr .NE. 0) THEN
+c$$$         PRINT*, "condsurf: Lecture echouee pour <FLIC>"
+c$$$         CALL abort
+c$$$      ENDIF
 c
       ELSE ! test sur newlmt
@@ -299,52 +316,4 @@
       PRINT*, 'SST, ALB, RUG, etc. sont lus pour jour: ', jour
 c
-      IF (ok_oasis) THEN
-C
-         CALL fromcpl(jour,(jjm+1)*iim,
-     .        cpl_sst,cpl_sic,cpl_alb_sst,cpl_alb_sic)
-         DO i = 1, iim-1 ! un seul point pour le pole nord
-            cpl_sst(i,1) = cpl_sst(iim,1)
-            cpl_sic(i,1) = cpl_sic(iim,1)
-            cpl_alb_sst(i,1) = cpl_alb_sst(iim,1)
-            cpl_alb_sic(i,1) = cpl_alb_sic(iim,1)
-         ENDDO
-         DO i = 2, iim ! un seul point pour le pole sud
-            cpl_sst(i,jjm+1) = cpl_sst(1,jjm+1)
-            cpl_sic(i,jjm+1) = cpl_sic(1,jjm+1)
-            cpl_alb_sst(i,jjm+1) = cpl_alb_sst(1,jjm+1)
-            cpl_alb_sic(i,jjm+1) = cpl_alb_sic(1,jjm+1)
-         ENDDO
-c
-         ig = 1
-         IF (pctsrf(ig,is_oce).GT.epsfra .OR.
-     .       pctsrf(ig,is_sic).GT.epsfra) THEN
-            pctsrf(ig,is_oce) = pctsrf(ig,is_oce)
-     .                        - (cpl_sic(1,1)-pctsrf(ig,is_sic))
-            pctsrf(ig,is_sic) = cpl_sic(1,1)
-            lmt_sst(ig) = cpl_sst(1,1)
-         ENDIF
-         DO j = 2, jjm
-         DO i = 1, iim
-         ig = ig + 1
-         IF (pctsrf(ig,is_oce).GT.epsfra .OR.
-     .       pctsrf(ig,is_sic).GT.epsfra) THEN
-           pctsrf(ig,is_oce) = pctsrf(ig,is_oce) 
-     .                       - (cpl_sic(i,j)-pctsrf(ig,is_sic))
-           pctsrf(ig,is_sic) = cpl_sic(i,j)
-           lmt_sst(ig) = cpl_sst(i,j)
-         ENDIF
-         ENDDO
-         ENDDO
-         ig = ig + 1
-         IF (pctsrf(ig,is_oce).GT.epsfra .OR.
-     .       pctsrf(ig,is_sic).GT.epsfra) THEN
-            pctsrf(ig,is_oce) = pctsrf(ig,is_oce)
-     .                        - (cpl_sic(1,jjm+1)-pctsrf(ig,is_sic))
-            pctsrf(ig,is_sic) = cpl_sic(1,jjm+1)
-            lmt_sst(ig) = cpl_sst(1,jjm+1)
-         ENDIF
-c
-      ENDIF ! ok_oasis
-c
       RETURN
       END
Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/conema3.F
===================================================================
--- LMDZ.3.3/tags/CCM1_0/libf/phylmd/conema3.F	(revision 300)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/conema3.F	(revision 300)
@@ -0,0 +1,281 @@
+c $Header$
+      SUBROUTINE conema (dtime,paprs,pplay,t,q,u,v,tra,ntra,
+     .             work1,work2,d_t,d_q,d_u,d_v,d_tra,
+     .             rain, snow, kbas, ktop,
+     .             upwd,dnwd,dnwdbis,bas,top,Ma,cape,tvp,rflag,
+     .             pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr)
+
+      IMPLICIT none
+c======================================================================
+c Auteur(s): Z.X. Li (LMD/CNRS) date: 19930818
+c Objet: schema de convection de Emanuel (1991) interface
+c Mai 1998: Interface modifiee pour implementation dans LMDZ
+c======================================================================
+c Arguments:
+c dtime---input-R-pas d'integration (s)
+c paprs---input-R-pression inter-couches (Pa)
+c pplay---input-R-pression au milieu des couches (Pa)
+c t-------input-R-temperature (K)
+c q-------input-R-humidite specifique (kg/kg)
+c u-------input-R-vitesse du vent zonal (m/s)
+c v-------input-R-vitesse duvent meridien (m/s)
+c tra-----input-R-tableau de rapport de melange des traceurs
+c work*: input et output: deux variables de travail,
+c                            on peut les mettre a 0 au debut
+c
+C d_t-----output-R-increment de la temperature
+c d_q-----output-R-increment de la vapeur d'eau
+c d_u-----output-R-increment de la vitesse zonale
+c d_v-----output-R-increment de la vitesse meridienne
+c d_tra---output-R-increment du contenu en traceurs
+c rain----output-R-la pluie (mm/s)
+c snow----output-R-la neige (mm/s)
+c kbas----output-R-bas du nuage (integer)
+c ktop----output-R-haut du nuage (integer)
+c upwd----output-R-saturated updraft mass flux (kg/m**2/s)
+c dnwd----output-R-saturated downdraft mass flux (kg/m**2/s)
+c dnwdbis-output-R-unsaturated downdraft mass flux (kg/m**2/s)
+c bas-----output-R-bas du nuage (real)
+c top-----output-R-haut du nuage (real)
+c Ma------output-R-flux ascendant non dilue (kg/m**2/s)
+c cape----output-R-CAPE
+c tvp-----output-R-virtual temperature of the lifted parcel
+c rflag---output-R-flag sur le fonctionnement de convect
+c pbase---output-R-pression a la base du nuage (Pa)
+c bbase---output-R-buoyancy a la base du nuage (K)
+c dtvpdt1-output-R-derivative of parcel virtual temp wrt T1 
+c dtvpdq1-output-R-derivative of parcel virtual temp wrt Q1 
+c dplcldt-output-R-derivative of the PCP pressure wrt T1
+c dplcldr-output-R-derivative of the PCP pressure wrt Q1
+c======================================================================
+c
+#include "dimensions.h"
+#include "dimphy.h"
+      INTEGER i, l,m,itra
+      INTEGER ntra,ntrac !number of tracers; if no tracer transport
+                         ! is needed, set ntra = 1 (or 0)
+      PARAMETER (ntrac=nqmx-2)
+      REAL dtime
+c
+
+c 
+      REAL paprs(klon,klev+1), pplay(klon,klev)
+      REAL t(klon,klev), q(klon,klev), d_t(klon,klev), d_q(klon,klev)
+      REAL u(klon,klev), v(klon,klev), tra(klon,klev,ntra)
+      REAL d_u(klon,klev), d_v(klon,klev), d_tra(klon,klev,ntra)
+      REAL work1(klon,klev), work2(klon,klev)
+      REAL upwd(klon,klev), dnwd(klon,klev), dnwdbis(klon,klev)
+      REAL rain(klon)
+      REAL snow(klon)
+      REAL cape(klon), tvp(klon,klev), rflag(klon)
+      REAL pbase(klon), bbase(klon)
+      REAL dtvpdt1(klon,klev), dtvpdq1(klon,klev)
+      REAL dplcldt(klon), dplcldr(klon)
+      INTEGER kbas(klon), ktop(klon)
+c
+      REAL em_t(klev)
+      REAL em_q(klev)
+      REAL em_qs(klev)
+      REAL em_u(klev), em_v(klev), em_tra(klev,ntrac)
+      REAL em_ph(klev+1), em_p(klev)
+      REAL em_work1(klev), em_work2(klev)
+      REAL em_precip, em_d_t(klev), em_d_q(klev)
+      REAL em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac)
+      REAL em_upwd(klev), em_dnwd(klev), em_dnwdbis(klev)
+      REAL em_dtvpdt1(klev), em_dtvpdq1(klev)
+      REAL em_dplcldt, em_dplcldr
+      SAVE em_t,em_q, em_qs, em_ph, em_p, em_work1, em_work2
+      SAVE em_u,em_v, em_tra
+      SAVE em_d_u,em_d_v, em_d_tra
+      SAVE em_precip, em_d_t, em_d_q, em_upwd, em_dnwd, em_dnwdbis
+      INTEGER em_bas, em_top
+      SAVE em_bas, em_top
+c
+      REAL zx_t, zx_qs, zdelta, zcor
+      INTEGER iflag
+      REAL sigsum
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c     VARIABLES A SORTIR
+cccccccccccccccccccccccccccccccccccccccccccccccccc
+ 
+      REAL emmip(klev) !variation de flux ascnon dilue i et i+1
+      SAVE emmip
+      real emMke(klev)
+      save emMke
+      real top
+      real bas
+      real emMa(klev)
+      save emMa
+      real Ma(klon,klev)
+      real Ment(klev,klev)
+      real Qent(klev,klev)
+      real TPS(klev),TLS(klev)
+      real SIJ(klev,klev)
+      real em_CAPE, em_TVP(klev)
+      real em_pbase, em_bbase
+      integer iw,j,k,ix,iy
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+ 
+c
+c$$$      print*,'debut conema'
+
+      DO 999 i = 1, klon
+      DO l = 1, klev+1
+         em_ph(l) = paprs(i,l) / 100.0
+      ENDDO
+c
+      DO l = 1, klev
+         em_p(l) = pplay(i,l) / 100.0
+         em_t(l) = t(i,l)
+         em_q(l) = q(i,l)
+         em_u(l) = u(i,l)
+         em_v(l) = v(i,l)
+         do itra = 1, ntra
+          em_tra(l,itra) = tra(i,l,itra)
+         enddo
+c$$$      print*,'em_t',em_t
+c$$$      print*,'em_q',em_q
+c$$$      print*,'em_qs',em_qs
+c$$$      print*,'em_u',em_u
+c$$$      print*,'em_v',em_v
+c$$$      print*,'em_tra',em_tra
+c$$$      print*,'em_p',em_p
+
+ 
+c
+         zx_t = em_t(l)
+         zdelta=MAX(0.,SIGN(1.,rtt-zx_t))
+         zx_qs= r2es * FOEEW(zx_t,zdelta)/em_p(l)/100.0
+         zx_qs=MIN(0.5,zx_qs)
+c$$$       print*,'zx_qs',zx_qs
+         zcor=1./(1.-retv*zx_qs) 
+         zx_qs=zx_qs*zcor
+         em_qs(l) = zx_qs
+c$$$      print*,'em_qs',em_qs
+c
+         em_work1(l) = work1(i,l)
+         em_work2(l) = work2(i,l)
+         emMke(l)=0
+c        emMa(l)=0
+c        Ma(i,l)=0
+     
+         em_dtvpdt1(l) = 0.
+         em_dtvpdq1(l) = 0.
+         dtvpdt1(i,l) = 0.
+         dtvpdq1(i,l) = 0.
+      ENDDO
+c
+      em_dplcldt = 0.
+      em_dplcldr = 0.
+      rain(i) = 0.0
+      snow(i) = 0.0
+      kbas(i) = 1
+      ktop(i) = 1
+c ajout SB:
+      bas = 1
+      top = 1
+ 
+ 
+c sb3d      write(*,1792) (em_work1(m),m=1,klev)
+1792  format('sig avant convect ',/,10(1X,E13.5))
+c
+c sb d      write(*,1793) (em_work2(m),m=1,klev)
+1793  format('w avant convect ',/,10(1X,E13.5))
+ 
+c$$$      print*,'avant convect' 
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c 
+      CALL convect(dtime, em_t, em_q, em_qs,em_u ,em_v ,
+     .              em_tra, em_p, em_ph,
+     .              klev, klev+1, klev-1,ntra, dtime, iflag,
+     .              em_d_t, em_d_q,em_d_u,em_d_v,
+     .              em_d_tra, em_precip,
+     .              em_bas, em_top,em_upwd, em_dnwd, em_dnwdbis,
+     .              em_work1, em_work2,emmip,emMke,emMa,Ment,
+c SB 11sept98     .              Qent,TPS,TLS,SIJ)
+c 19oct98     .              Qent,TPS,TLS,SIJ,em_CAPE,em_TVP)
+     .  Qent,TPS,TLS,SIJ,em_CAPE,em_TVP,em_pbase,em_bbase,
+     .  em_dtvpdt1,em_dtvpdq1,em_dplcldt,em_dplcldr)
+c
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c
+c SB:
+      if (iflag.ne.1 .and. iflag.ne.4) then
+         em_CAPE = 0.
+      do l = 1, klev
+         em_upwd(l) = 0.
+         em_dnwd(l) = 0.
+         em_dnwdbis(l) = 0.
+         emMa(l) = 0.
+         em_TVP(l) = 0.
+      enddo
+      endif
+c fin SB
+c
+c  If sig has been set to zero, then set Ma to zero
+c
+      sigsum = 0.
+      do k = 1,klev
+        sigsum = sigsum + em_work1(k)
+      enddo
+      if (sigsum .eq. 0.0) then
+        do k = 1,klev
+          emMa(k) = 0.
+        enddo
+      endif
+c
+c sb3d       print*,'i, iflag=',i,iflag
+c 
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c
+c       SORTIE DES ICB ET INB
+c       en fait inb et icb correspondent au niveau ou se trouve
+c       le nuage,le numero d'interface
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+ 
+c modif SB:
+      if (iflag.EQ.1 .or. iflag.EQ.4) then
+       top=em_top
+       bas=em_bas
+       kbas(i) = em_bas
+       ktop(i) = em_top
+      endif
+ 
+      pbase(i) = em_pbase
+      bbase(i) = em_bbase
+      rain(i) = em_precip/ 86400.0
+      snow(i) = 0.0
+      cape(i) = em_CAPE
+      rflag(i) = float(iflag)
+c SB      kbas(i) = em_bas
+c SB      ktop(i) = em_top
+      dplcldt(i) = em_dplcldt
+      dplcldr(i) = em_dplcldr
+      DO l = 1, klev
+         d_t(i,l) = dtime * em_d_t(l) 
+         d_q(i,l) = dtime * em_d_q(l)
+         d_u(i,l) = dtime * em_d_u(l)
+         d_v(i,l) = dtime * em_d_v(l)
+         do itra = 1, ntra
+         d_tra(i,l,itra) = dtime * em_d_tra(l,itra)
+         enddo
+         upwd(i,l) = em_upwd(l)
+         dnwd(i,l) = em_dnwd(l)
+         dnwdbis(i,l) = em_dnwdbis(l)
+         work1(i,l) = em_work1(l)
+         work2(i,l) = em_work2(l)
+         Ma(i,l)=emMa(l)
+         tvp(i,l)=em_TVP(l)
+         dtvpdt1(i,l) = em_dtvpdt1(l)
+         dtvpdq1(i,l) = em_dtvpdq1(l)
+      ENDDO
+  999 CONTINUE
+ 
+
+      RETURN
+      END
+
